/* =========================================================================

NAME: RotateShadows

AUTHOR: Filianin Sergey (dtp@mail.ru)
DATE  : 05.09.2004

COMMENT:
Rotate Drop Shadow of selection
============================================================================ */

// Check documents open
if (app.documents.length<1) {
	alert("No document open!\nOpen document, select any objects and try again.");
	exit()
}
// Check object select
if (app.selection.length<1) {
	alert("No object selected!\nSelect any objects and try again.");
	exit()
}

// Create script user interface
var myDialog = app.dialogs.add({name:"Rotate Drop Shadow"})
var myColumn = myDialog.dialogColumns.add()
with(myColumn.dialogRows.add()){
	staticTexts.add({staticLabel:"Angle: "})
}
with(myColumn.dialogRows.add()){
	var myAngle = realEditboxes.add({editValue:0});	
}
// Show dialog
var myResult = myDialog.show();
if (myResult == false) {
	exit()
}

var myPiAngle=-myAngle.editValue*3.1415/180;
for (myCounter=0; myCounter<app.selection.length; myCounter++)
{
	var mySelection = app.selection[myCounter];
	RotateShadow (mySelection, myPiAngle);
}
	
function RotateShadow(myObject, Angle)
{
	if (myObject.constructor.name == "Group")
	{
		for (i=0; i<myObject.allPageItems.length; i++)
		{
			if (myObject.allPageItems[i].constructor.name!="Group") 
			{
				RotateShadow(myObject.allPageItems[i], Angle);
			}
		}
	}
	if (myObject.shadowMode==ShadowMode.drop)
	{
		var dx=myObject.shadowXOffset;
		var dy=myObject.shadowYOffset;
		var radius=Math.sqrt(dx*dx+dy*dy);
		if (dx) 
				{
						var betta=Math.atan(dy/dx);
				}else
				{
						if (dy>0) var betta=3.1415/2;
						else var betta=-3.1415/2;
				}
		var ndx=Math.cos(Angle+betta)*radius;
		var ndy=Math.sin(Angle+betta)*radius;
		myObject.shadowXOffset=ndx;
		myObject.shadowYOffset=ndy;
	}
	return;
}